Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34921)
@@ -2,5 +2,5 @@
 # File:         QuickTime.pm
 #
-# Description:  Read QuickTime, MP4 and M4A meta information
+# Description:  Read QuickTime and MP4 meta information
 #
 # Revisions:    10/04/2005 - P. Harvey Created
@@ -9,18 +9,33 @@
 #               07/27/2010 - P. Harvey Updated to 2010-05-03 QuickTime spec
 #
-# References:   1) http://developer.apple.com/mac/library/documentation/QuickTime/QTFF/QTFFChap1/qtff1.html
-#               2) http://search.cpan.org/dist/MP4-Info-1.04/
-#               3) http://www.geocities.com/xhelmboyx/quicktime/formats/mp4-layout.txt
-#               4) http://wiki.multimedia.cx/index.php?title=Apple_QuickTime
-#               5) ISO 14496-12 (http://neuron2.net/library/avc/c041828_ISO_IEC_14496-12_2005(E).pdf)
-#               6) ISO 14496-16 (http://www.iec-normen.de/previewpdf/info_isoiec14496-16%7Bed2.0%7Den.pdf)
-#               7) http://atomicparsley.sourceforge.net/mpeg-4files.html
-#               8) http://wiki.multimedia.cx/index.php?title=QuickTime_container
-#               9) http://www.adobe.com/devnet/xmp/pdfs/XMPSpecificationPart3.pdf (Oct 2008)
-#               10) http://code.google.com/p/mp4v2/wiki/iTunesMetadata
-#               11) http://www.canieti.com.mx/assets/files/1011/IEC_100_1384_DC.pdf
-#               12) QuickTime file format specification 2010-05-03
-#               13) http://www.adobe.com/devnet/flv/pdf/video_file_format_spec_v10.pdf
-#               14) http://standards.iso.org/ittf/PubliclyAvailableStandards/c051533_ISO_IEC_14496-12_2008.zip
+# References:
+#
+#   1) http://developer.apple.com/mac/library/documentation/QuickTime/QTFF/QTFFChap1/qtff1.html
+#   2) http://search.cpan.org/dist/MP4-Info-1.04/
+#   3) http://www.geocities.com/xhelmboyx/quicktime/formats/mp4-layout.txt
+#   4) http://wiki.multimedia.cx/index.php?title=Apple_QuickTime
+#   5) ISO 14496-12 (http://read.pudn.com/downloads64/ebook/226547/ISO_base_media_file_format.pdf)
+#   6) ISO 14496-16 (http://www.iec-normen.de/previewpdf/info_isoiec14496-16%7Bed2.0%7Den.pdf)
+#   7) http://atomicparsley.sourceforge.net/mpeg-4files.html
+#   8) http://wiki.multimedia.cx/index.php?title=QuickTime_container
+#   9) http://www.adobe.com/devnet/xmp/pdfs/XMPSpecificationPart3.pdf (Oct 2008)
+#   10) http://code.google.com/p/mp4v2/wiki/iTunesMetadata
+#   11) http://www.canieti.com.mx/assets/files/1011/IEC_100_1384_DC.pdf
+#   12) QuickTime file format specification 2010-05-03
+#   13) http://www.adobe.com/devnet/flv/pdf/video_file_format_spec_v10.pdf
+#   14) http://standards.iso.org/ittf/PubliclyAvailableStandards/c051533_ISO_IEC_14496-12_2008.zip
+#   15) http://getid3.sourceforge.net/source/module.audio-video.quicktime.phps
+#   16) http://qtra.apple.com/atoms.html
+#   17) http://www.etsi.org/deliver/etsi_ts/126200_126299/126244/10.01.00_60/ts_126244v100100p.pdf
+#   18) https://github.com/appsec-labs/iNalyzer/blob/master/scinfo.m
+#   19) http://nah6.com/~itsme/cvs-xdadevtools/iphone/tools/decodesinf.pl
+#   20) https://developer.apple.com/legacy/library/documentation/quicktime/reference/QT7-1_Update_Reference/QT7-1_Update_Reference.pdf
+#   21) Francois Bonzon private communication
+#   22) https://developer.apple.com/library/mac/documentation/QuickTime/QTFF/Metadata/Metadata.html
+#   23) http://atomicparsley.sourceforge.net/mpeg-4files.html
+#   24) https://github.com/sergiomb2/libmp4v2/wiki/iTunesMetadata
+#   25) https://cconcolato.github.io/mp4ra/atoms.html
+#   26) https://github.com/SamsungVR/android_upload_sdk/blob/master/SDKLib/src/main/java/com/samsung/msca/samsungvr/sdk/UserVideo.java
+#   27) https://exiftool.org/forum/index.php?topic=11517.0
 #------------------------------------------------------------------------------
 
@@ -28,58 +43,47 @@
 
 use strict;
-use vars qw($VERSION);
+use vars qw($VERSION $AUTOLOAD %stringEncoding);
 use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
-
-$VERSION = '1.48';
-
-sub FixWrongFormat($);
+use Image::ExifTool::GPS;
+
+$VERSION = '2.59';
+
 sub ProcessMOV($$;$);
 sub ProcessKeys($$$);
+sub ProcessMetaKeys($$$);
 sub ProcessMetaData($$$);
+sub ProcessEncodingParams($$$);
+sub ProcessSampleDesc($$$);
+sub ProcessHybrid($$$);
+sub ProcessRights($$$);
+# ++vvvvvvvvvvvv++ (in QuickTimeStream.pl)
+sub Process_mebx($$$);
+sub Process_3gf($$$);
+sub Process_gps0($$$);
+sub Process_gsen($$$);
+sub ProcessRIFFTrailer($$$);
+sub ProcessTTAD($$$);
+sub ProcessNMEA($$$);
+sub SaveMetaKeys($$$);
+# ++^^^^^^^^^^^^++
+sub ParseItemLocation($$);
+sub ParseContentDescribes($$);
+sub ParseItemInfoEntry($$);
+sub ParseItemPropAssoc($$);
+sub FixWrongFormat($);
+sub GetMatrixStructure($$);
 sub ConvertISO6709($);
+sub ConvInvISO6709($);
+sub ConvertChapterList($);
+sub PrintChapter($);
 sub PrintGPSCoordinates($);
-
-# information for time/date-based tags (time zero is Jan 1, 1904)
-my %timeInfo = (
-    # Note: This value will be in UTC if generated by a system that is aware of the time zone
-    ValueConv => 'ConvertUnixTime($val - ((66 * 365 + 17) * 24 * 3600))',
-    PrintConv => '$self->ConvertDateTime($val)',
-    # (can't put Groups here because they aren't constant!)
-);
-# information for duration tags
-my %durationInfo = (
-    ValueConv => '$$self{TimeScale} ? $val / $$self{TimeScale} : $val',
-    PrintConv => '$$self{TimeScale} ? ConvertDuration($val) : $val',
-);
-
-# 4-character Vendor ID codes (ref PH)
-my %vendorID = (
-    appl => 'Apple',
-    fe20 => 'Olympus (fe20)', # (FE200)
-    FFMP => 'FFmpeg',
-   'GIC '=> 'General Imaging Co.',
-    kdak => 'Kodak',
-    KMPI => 'Konica-Minolta',
-    mino => 'Minolta',
-    niko => 'Nikon',
-    NIKO => 'Nikon',
-    olym => 'Olympus',
-    pana => 'Panasonic',
-    pent => 'Pentax',
-    pr01 => 'Olympus (pr01)', # (FE100,FE110,FE115)
-    sany => 'Sanyo',
-   'SMI '=> 'Sorenson Media Inc.',
-    ZORA => 'Zoran Corporation',
-);
-
-# QuickTime data atom encodings for string types (ref 12)
-my %stringEncoding = (
-    1 => 'UTF8',
-    2 => 'UTF16',
-    3 => 'ShiftJIS',
-    4 => 'UTF8',
-    5 => 'UTF16',
-);
+sub PrintInvGPSCoordinates($);
+sub UnpackLang($;$);
+sub WriteKeys($$$);
+sub WriteQuickTime($$$);
+sub WriteMOV($$);
+sub GetLangInfo($$);
+sub CheckQTValue($$$);
 
 # MIME types for all entries in the ftypLookup with file extensions
@@ -88,4 +92,5 @@
    '3G2' => 'video/3gpp2',
    '3GP' => 'video/3gpp',
+    AAX  => 'audio/vnd.audible.aax',
     DVB  => 'video/vnd.dvb.file',
     F4A  => 'audio/mp4',
@@ -100,40 +105,11 @@
     MOV  => 'video/quicktime',
     MQV  => 'video/quicktime',
-);
-
-my %graphicsMode = (
-    # (ref http://homepage.mac.com/vanhoek/MovieGuts%20docs/64.html)
-    0x00 => 'srcCopy',
-    0x01 => 'srcOr',
-    0x02 => 'srcXor',
-    0x03 => 'srcBic',
-    0x04 => 'notSrcCopy',
-    0x05 => 'notSrcOr',
-    0x06 => 'notSrcXor',
-    0x07 => 'notSrcBic',
-    0x08 => 'patCopy',
-    0x09 => 'patOr',
-    0x0a => 'patXor',
-    0x0b => 'patBic',
-    0x0c => 'notPatCopy',
-    0x0d => 'notPatOr',
-    0x0e => 'notPatXor',
-    0x0f => 'notPatBic',
-    0x20 => 'blend',
-    0x21 => 'addPin',
-    0x22 => 'addOver',
-    0x23 => 'subPin',
-    0x24 => 'transparent',
-    0x25 => 'addMax',
-    0x26 => 'subOver',
-    0x27 => 'addMin',
-    0x31 => 'grayishTextOr',
-    0x32 => 'hilite',
-    0x40 => 'ditherCopy',
-    # the following ref ISO/IEC 15444-3
-    0x100 => 'Alpha',
-    0x101 => 'White Alpha',
-    0x102 => 'Pre-multiplied Black Alpha',
-    0x110 => 'Component Alpha',
+    HEIC => 'image/heic',
+    HEVC => 'image/heic-sequence',
+    HEICS=> 'image/heic-sequence',
+    HEIF => 'image/heif',
+    HEIFS=> 'image/heif-sequence',
+    AVIF => 'image/avif', #PH (NC)
+    CRX  => 'video/x-canon-crx',    # (will get overridden)
 );
 
@@ -156,4 +132,5 @@
     '3gp6' => '3GPP Media (.3GP) Release 6 Streaming Servers', # video/3gpp
     '3gs7' => '3GPP Media (.3GP) Release 7 Streaming Servers', # video/3gpp
+    'aax ' => 'Audible Enhanced Audiobook (.AAX)', #PH
     'avc1' => 'MP4 Base w/ AVC ext [ISO 14496-12:2005]', # video/mp4
     'CAEP' => 'Canon Digital Camera',
@@ -191,4 +168,5 @@
     'jpx ' => 'JPEG 2000 with extensions (.JPX) [ISO 15444-2]', # image/jpx
     'KDDI' => '3GPP2 EZmovie for KDDI 3G cellphones', # video/3gpp2
+    #LCAG  => (found in CompatibleBrands of Leica MOV videos)
     'M4A ' => 'Apple iTunes AAC-LC (.M4A) Audio', # audio/x-m4a
     'M4B ' => 'Apple iTunes AAC-LC (.M4B) Audio Book', # audio/mp4
@@ -227,4 +205,240 @@
     'ssc1' => 'Samsung stereoscopic, single stream',
     'ssc2' => 'Samsung stereoscopic, dual stream',
+    'XAVC' => 'Sony XAVC', #PH
+    'heic' => 'High Efficiency Image Format HEVC still image (.HEIC)', # image/heic
+    'hevc' => 'High Efficiency Image Format HEVC sequence (.HEICS)', # image/heic-sequence
+    'mif1' => 'High Efficiency Image Format still image (.HEIF)', # image/heif
+    'msf1' => 'High Efficiency Image Format sequence (.HEIFS)', # image/heif-sequence
+    'heix' => 'High Efficiency Image Format still image (.HEIF)', # image/heif (ref PH, Canon 1DXmkIII)
+    'avif' => 'AV1 Image File Format (.AVIF)', # image/avif
+    'crx ' => 'Canon Raw (.CRX)', #PH (CR3 or CRM; use Canon CompressorVersion to decide)
+);
+
+# information for int32u date/time tags (time zero is Jan 1, 1904)
+my %timeInfo = (
+    Notes => 'converted from UTC to local time if the QuickTimeUTC option is set',
+    Shift => 'Time',
+    Writable => 1,
+    Permanent => 1,
+    DelValue => 0,
+    # It is not uncommon for brain-dead software to use the wrong time zero,
+    # so assume a time zero of Jan 1, 1970 if the date is before this
+    # Note: This value will be in UTC if generated by a system that is aware of the time zone
+    RawConv => q{
+        my $offset = (66 * 365 + 17) * 24 * 3600;
+        return $val - $offset if $val >= $offset or $$self{OPTIONS}{QuickTimeUTC};
+        if ($val and not $$self{IsWriting}) {
+            $self->WarnOnce('Patched incorrect time zero for QuickTime date/time tag',1);
+        }
+        return $val;
+    },
+    RawConvInv => q{
+        if ($$self{FileType} eq 'CR3' and not $self->Options('QuickTimeUTC')) {
+            # convert to UTC
+            my $offset = (66 * 365 + 17) * 24 * 3600;
+            $val = ConvertUnixTime($val - $offset);
+            $val = GetUnixTime($val, 1) + $offset;
+        }
+        return $val;
+    },
+    # (all CR3 files store UTC times - PH)
+    ValueConv => 'ConvertUnixTime($val, $self->Options("QuickTimeUTC") || $$self{FileType} eq "CR3")',
+    ValueConvInv => 'GetUnixTime($val, $self->Options("QuickTimeUTC")) + (66 * 365 + 17) * 24 * 3600',
+    PrintConv => '$self->ConvertDateTime($val)',
+    PrintConvInv => '$self->InverseDateTime($val)',
+    # (can't put Groups here because they aren't constant!)
+);
+# information for duration tags
+my %durationInfo = (
+    ValueConv => '$$self{TimeScale} ? $val / $$self{TimeScale} : $val',
+    PrintConv => '$$self{TimeScale} ? ConvertDuration($val) : $val',
+);
+# handle unknown tags
+my %unknownInfo = (
+    Unknown => 1,
+    ValueConv => '$val =~ /^([\x20-\x7e]*)\0*$/ ? $1 : \$val',
+);
+
+# multi-language text with 6-byte header
+my %langText = ( IText => 6 );
+
+# parsing for most of the 3gp udta language text boxes
+my %langText3gp = (
+    Notes => 'used in 3gp videos',
+    Avoid => 1,
+    IText => 6,
+);
+
+# 4-character Vendor ID codes (ref PH)
+my %vendorID = (
+    appl => 'Apple',
+    fe20 => 'Olympus (fe20)', # (FE200)
+    FFMP => 'FFmpeg',
+   'GIC '=> 'General Imaging Co.',
+    kdak => 'Kodak',
+    KMPI => 'Konica-Minolta',
+    leic => 'Leica',
+    mino => 'Minolta',
+    niko => 'Nikon',
+    NIKO => 'Nikon',
+    olym => 'Olympus',
+    pana => 'Panasonic',
+    pent => 'Pentax',
+    pr01 => 'Olympus (pr01)', # (FE100,FE110,FE115)
+    sany => 'Sanyo',
+   'SMI '=> 'Sorenson Media Inc.',
+    ZORA => 'Zoran Corporation',
+   'AR.D'=> 'Parrot AR.Drone',
+   ' KD '=> 'Kodak', # (FZ201)
+);
+
+# QuickTime data atom encodings for string types (ref 12)
+%stringEncoding = (
+    1 => 'UTF8',
+    2 => 'UTF16',
+    3 => 'ShiftJIS',
+    4 => 'UTF8',
+    5 => 'UTF16',
+);
+
+my %graphicsMode = (
+    # (ref http://homepage.mac.com/vanhoek/MovieGuts%20docs/64.html)
+    0x00 => 'srcCopy',
+    0x01 => 'srcOr',
+    0x02 => 'srcXor',
+    0x03 => 'srcBic',
+    0x04 => 'notSrcCopy',
+    0x05 => 'notSrcOr',
+    0x06 => 'notSrcXor',
+    0x07 => 'notSrcBic',
+    0x08 => 'patCopy',
+    0x09 => 'patOr',
+    0x0a => 'patXor',
+    0x0b => 'patBic',
+    0x0c => 'notPatCopy',
+    0x0d => 'notPatOr',
+    0x0e => 'notPatXor',
+    0x0f => 'notPatBic',
+    0x20 => 'blend',
+    0x21 => 'addPin',
+    0x22 => 'addOver',
+    0x23 => 'subPin',
+    0x24 => 'transparent',
+    0x25 => 'addMax',
+    0x26 => 'subOver',
+    0x27 => 'addMin',
+    0x31 => 'grayishTextOr',
+    0x32 => 'hilite',
+    0x40 => 'ditherCopy',
+    # the following ref ISO/IEC 15444-3
+    0x100 => 'Alpha',
+    0x101 => 'White Alpha',
+    0x102 => 'Pre-multiplied Black Alpha',
+    0x110 => 'Component Alpha',
+);
+
+my %channelLabel = (
+    0xFFFFFFFF => 'Unknown',
+    0 => 'Unused',
+    100 => 'UseCoordinates',
+    1 => 'Left',
+    2 => 'Right',
+    3 => 'Center',
+    4 => 'LFEScreen',
+    5 => 'LeftSurround',
+    6 => 'RightSurround',
+    7 => 'LeftCenter',
+    8 => 'RightCenter',
+    9 => 'CenterSurround',
+    10 => 'LeftSurroundDirect',
+    11 => 'RightSurroundDirect',
+    12 => 'TopCenterSurround',
+    13 => 'VerticalHeightLeft',
+    14 => 'VerticalHeightCenter',
+    15 => 'VerticalHeightRight',
+    16 => 'TopBackLeft',
+    17 => 'TopBackCenter',
+    18 => 'TopBackRight',
+    33 => 'RearSurroundLeft',
+    34 => 'RearSurroundRight',
+    35 => 'LeftWide',
+    36 => 'RightWide',
+    37 => 'LFE2',
+    38 => 'LeftTotal',
+    39 => 'RightTotal',
+    40 => 'HearingImpaired',
+    41 => 'Narration',
+    42 => 'Mono',
+    43 => 'DialogCentricMix',
+    44 => 'CenterSurroundDirect',
+    45 => 'Haptic',
+    200 => 'Ambisonic_W',
+    201 => 'Ambisonic_X',
+    202 => 'Ambisonic_Y',
+    203 => 'Ambisonic_Z',
+    204 => 'MS_Mid',
+    205 => 'MS_Side',
+    206 => 'XY_X',
+    207 => 'XY_Y',
+    301 => 'HeadphonesLeft',
+    302 => 'HeadphonesRight',
+    304 => 'ClickTrack',
+    305 => 'ForeignLanguage',
+    400 => 'Discrete',
+    0x10000 => 'Discrete_0',
+    0x10001 => 'Discrete_1',
+    0x10002 => 'Discrete_2',
+    0x10003 => 'Discrete_3',
+    0x10004 => 'Discrete_4',
+    0x10005 => 'Discrete_5',
+    0x10006 => 'Discrete_6',
+    0x10007 => 'Discrete_7',
+    0x10008 => 'Discrete_8',
+    0x10009 => 'Discrete_9',
+    0x1000a => 'Discrete_10',
+    0x1000b => 'Discrete_11',
+    0x1000c => 'Discrete_12',
+    0x1000d => 'Discrete_13',
+    0x1000e => 'Discrete_14',
+    0x1000f => 'Discrete_15',
+    0x1ffff => 'Discrete_65535',
+);
+
+# properties which don't get inherited from the parent
+my %dontInherit = (
+    ispe => 1,  # size of parent may be different
+    hvcC => 1,  # (likely redundant)
+);
+
+# tags that may be duplicated and directories that may contain duplicate tags
+# (used only to avoid warnings when Validate-ing)
+my %dupTagOK = ( mdat => 1, trak => 1, free => 1, infe => 1, sgpd => 1, dimg => 1, CCDT => 1,
+                 sbgp => 1, csgm => 1, uuid => 1, cdsc => 1, maxr => 1, '----' => 1 );
+my %dupDirOK = ( ipco => 1, '----' => 1 );
+
+# the usual atoms required to decode timed metadata with the ExtractEmbedded option
+my %eeStd = ( stco => 'stbl', co64 => 'stbl', stsz => 'stbl', stz2 => 'stbl',
+              stsc => 'stbl', stts => 'stbl' );
+
+# boxes and their containers for the various handler types that we want to save
+# when the ExtractEmbedded is enabled (currently only the 'gps ' container name is
+# used, but others have been checked against all available sample files and may be
+# useful in the future if the names are used for different boxes on other locations)
+my %eeBox = (
+    # (note: vide is only processed if specific atoms exist in the VideoSampleDesc)
+    vide => { %eeStd,
+        JPEG => 'stsd',
+    },
+    text => { %eeStd },
+    meta => { %eeStd },
+    sbtl => { %eeStd },
+    data => { %eeStd },
+    camm => { %eeStd }, # (Insta360)
+    ctbx => { %eeStd }, # (GM cars)
+    ''   => { 'gps ' => 'moov', 'GPS ' => 'main' }, # (no handler -- in top level 'moov' box, and main)
+);
+# boxes to save when ExtractEmbedded is set to 2 or higher
+my %eeBox2 = (
+    vide => { avcC => 'stsd' }, # (parses H264 video stream)
 );
 
@@ -232,14 +446,58 @@
 %Image::ExifTool::QuickTime::Main = (
     PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime, # (only needs to be defined for directories to process when writing)
     GROUPS => { 2 => 'Video' },
-    NOTES => q{
-        The QuickTime format is used for many different types of audio, video and
-        image files.  Exiftool extracts meta information from the UserData atom
-        (including some proprietary manufacturer-specific information), as well as
-        extracting various audio, video and image parameters.  Tags with a question
-        mark after their name are not extracted unless the Unknown option is set.
-    },
-    free => { Unknown => 1, Binary => 1 },
-    skip => { Unknown => 1, Binary => 1 },
+    meta => { # 'meta' is found here in my Sony ILCE-7S MP4 sample - PH
+        Name => 'Meta',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::QuickTime::Meta',
+            Start => 4, # skip 4-byte version number header
+        },
+    },
+    meco => { #ISO14496-12:2015
+        Name => 'OtherMeta',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::OtherMeta' },
+    },
+    free => [
+        {
+            Name => 'KodakFree',
+            # (found in Kodak M5370 MP4 videos)
+            Condition => '$$valPt =~ /^\0\0\0.Seri/s',
+            SubDirectory => { TagTable => 'Image::ExifTool::Kodak::Free' },
+        },{
+            Name => 'Pittasoft',
+            # (Pittasoft Blackview dashcam MP4 videos)
+            Condition => '$$valPt =~ /^\0\0..(cprt|sttm|ptnm|ptrh|thum|gps |3gf )/s',
+            SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::Pittasoft' },
+        },{
+            Unknown => 1,
+            Binary => 1,
+        },
+        # (also Samsung WB750 uncompressed thumbnail data starting with "SDIC\0")
+    ],
+    # fre1 - 4 bytes: "june" (Kodak PixPro SP360)
+    frea => {
+        Name => 'Kodak_frea',
+        SubDirectory => { TagTable => 'Image::ExifTool::Kodak::frea' },
+    },
+    skip => [
+        {
+            Name => 'CanonSkip',
+            Condition => '$$valPt =~ /^\0.{3}(CNDB|CNCV|CNMN|CNFV|CNTH|CNDM)/s',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::Skip' },
+        },
+        {
+            Name => 'PreviewImage', # (found in  DuDuBell M1 dashcam MOV files)
+            Groups => { 2 => 'Preview' },
+            Condition => '$$valPt =~ /^.{12}\xff\xd8\xff/',
+            Binary => 1,
+            RawConv => q{
+                my $len = Get32u(\$val, 8);
+                return undef unless length($val) >= $len + 12;
+                return substr($val, 12, $len);
+            },
+        },
+        { Name => 'Skip', Unknown => 1, Binary => 1 },
+    ],
     wide => { Unknown => 1, Binary => 1 },
     ftyp => { #MP4
@@ -253,17 +511,26 @@
     PICT => {
         Name => 'PreviewPICT',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
     pict => { #8
         Name => 'PreviewPICT',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
+    # (note that moov is present for an HEIF sequence)
     moov => {
         Name => 'Movie',
         SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::Movie' },
     },
-    mdat => { Name => 'MovieData', Unknown => 1, Binary => 1 },
+    moof => {
+        Name => 'MovieFragment',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::MovieFragment' },
+    },
+    # mfra - movie fragment random access: contains tfra (track fragment random access), and
+    #           mfro (movie fragment random access offset) (ref 5)
+    mdat => { Name => 'MediaData', Unknown => 1, Binary => 1 },
     'mdat-size' => {
-        Name => 'MovieDataSize',
+        Name => 'MediaDataSize',
         Notes => q{
             not a real tag ID, this tag represents the size of the 'mdat' data in bytes
@@ -271,9 +538,12 @@
         },
     },
+    'mdat-offset' => 'MediaDataOffset',
     junk => { Unknown => 1, Binary => 1 }, #8
     uuid => [
         { #9 (MP4 files)
-            Name => 'UUID-XMP',
+            Name => 'XMP',
+            # *** this is where ExifTool writes XMP in MP4 videos (as per XMP spec) ***
             Condition => '$$valPt=~/^\xbe\x7a\xcf\xcb\x97\xa9\x42\xe8\x9c\x71\x99\x94\x91\xe3\xaf\xac/',
+            WriteGroup => 'XMP',    # (write main XMP tags here)
             SubDirectory => {
                 TagTable => 'Image::ExifTool::XMP::Main',
@@ -291,5 +561,5 @@
         { #PH (Flip MP4 files)
             Name => 'UUID-Flip',
-            Condition => '$$valPt=~/\x4a\xb0\x3b\x0f\x61\x8d\x40\x75\x82\xb2\xd9\xfa\xce\xd3\x5f\xf5/',
+            Condition => '$$valPt=~/^\x4a\xb0\x3b\x0f\x61\x8d\x40\x75\x82\xb2\xd9\xfa\xce\xd3\x5f\xf5/',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::QuickTime::Flip',
@@ -298,10 +568,149 @@
         },
         # "\x98\x7f\xa3\xdf\x2a\x85\x43\xc0\x8f\x8f\xd9\x7c\x47\x1e\x8e\xea" - unknown data in Flip videos
+        { #PH (Canon CR3)
+            Name => 'UUID-Canon2',
+            WriteLast => 1, # MUST come after mdat or DPP will drop mdat when writing!
+            Condition => '$$valPt=~/^\x21\x0f\x16\x87\x91\x49\x11\xe4\x81\x11\x00\x24\x21\x31\xfc\xe4/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Canon::uuid2',
+                Start => 16,
+            },
+        },
+        { # (ref https://github.com/JamesHeinrich/getID3/blob/master/getid3/module.audio-video.quicktime.php)
+            Name => 'SensorData', # sensor data for the 360Fly
+            Condition => '$$valPt=~/^\xef\xe1\x58\x9a\xbb\x77\x49\xef\x80\x95\x27\x75\x9e\xb1\xdc\x6f/ and $$self{OPTIONS}{ExtractEmbedded}',
+            SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::Tags360Fly' },
+        },
+        {
+            Name => 'SensorData',
+            Condition => '$$valPt=~/^\xef\xe1\x58\x9a\xbb\x77\x49\xef\x80\x95\x27\x75\x9e\xb1\xdc\x6f/',
+            Notes => 'raw 360Fly sensor data without ExtractEmbedded option',
+            RawConv => q{
+                $self->WarnOnce('Use the ExtractEmbedded option to decode timed SensorData',3);
+                return \$val;
+            },
+        },
+        { #PH (Canon CR3)
+            Name => 'PreviewImage',
+            Condition => '$$valPt=~/^\xea\xf4\x2b\x5e\x1c\x98\x4b\x88\xb9\xfb\xb7\xdc\x40\x6e\x4d\x16/',
+            Groups => { 2 => 'Preview' },
+            # 0x00 - undef[16]: UUID
+            # 0x10 - int32u[2]: "0 1" (version and/or item count?)
+            # 0x18 - int32u: PRVW atom size
+            # 0x20 - int32u: 'PRVW'
+            # 0x30 - int32u: 0
+            # 0x34 - int16u: 1
+            # 0x36 - int16u: image width
+            # 0x38 - int16u: image height
+            # 0x3a - int16u: 1
+            # 0x3c - int32u: preview length
+            RawConv => '$val = substr($val, 0x30); $self->ValidateImage(\$val, $tag)',
+        },
         { #8
             Name => 'UUID-Unknown',
-            Unknown => 1,
-            Binary => 1,
+            %unknownInfo,
         },
     ],
+    _htc => {
+        Name => 'HTCInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::HTCInfo' },
+    },
+    udta => {
+        Name => 'UserData',
+        SubDirectory => { TagTable => 'Image::ExifTool::FLIR::UserData' },
+    },
+    thum => { #PH
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
+   'thm ' => { #PH (70mai A800)
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Binary => 1,
+    },
+    ardt => { #PH
+        Name => 'ARDroneFile',
+        ValueConv => 'length($val) > 4 ? substr($val,4) : $val', # remove length
+    },
+    prrt => { #PH
+        Name => 'ARDroneTelemetry',
+        Notes => q{
+            telemetry information for each video frame: status1, status2, time, pitch,
+            roll, yaw, speed, altitude
+        },
+        ValueConv => q{
+            my $size = length $val;
+            return \$val if $size < 12 or not $$self{OPTIONS}{Binary};
+            my $len = Get16u(\$val, 2);
+            my $str = '';
+            SetByteOrder('II');
+            my $pos = 12;
+            while ($pos + $len <= $size) {
+                my $s1 = Get16u(\$val, $pos);
+                # s2: 7=take-off?, 3=moving, 4=hovering, 9=landing?, 2=landed
+                my $s2 = Get16u(\$val, $pos + 2);
+                $str .= "$s1 $s2";
+                my $num = int(($len-4)/4);
+                my ($i, $v);
+                for ($i=0; $i<$num; ++$i) {
+                    my $pt = $pos + 4 + $i * 4;
+                    if ($i > 0 && $i < 4) {
+                        $v = GetFloat(\$val, $pt); # pitch/roll/yaw
+                    } else {
+                        $v = Get32u(\$val, $pt);
+                        # convert time to sec, and speed(NC)/altitude to metres
+                        $v /= 1000 if $i <= 5;
+                    }
+                    $str .= " $v";
+                }
+                $str .= "\n";
+                $pos += $len;
+            }
+            SetByteOrder('MM');
+            return \$str;
+        },
+    },
+    udat => { #PH (GPS NMEA-format log written by Datakam Player software)
+        Name => 'GPSLog',
+        Binary => 1,    # (actually ASCII, but very lengthy)
+    },
+    # meta - proprietary XML information written by some Flip cameras - PH
+    # beam - 16 bytes found in an iPhone video
+    IDIT => { #PH (written by DuDuBell M1, VSYS M6L dashcams)
+        Name => 'DateTimeOriginal',
+        Description => 'Date/Time Original',
+        Groups => { 2 => 'Time' },
+        Format => 'string', # (removes trailing "\0")
+        Shift => 'Time',
+        Writable => 1,
+        Permanent => 1,
+        DelValue => '0000-00-00T00:00:00+0000',
+        ValueConv => '$val=~tr/-/:/; $val',
+        ValueConvInv => '$val=~s/(\d+):(\d+):/$1-$2-/; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,1)', # (add time zone if it didn't exist)
+    },
+    gps0 => { #PH (DuDuBell M1, VSYS M6L)
+        Name => 'GPSTrack',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::QuickTime::Stream',
+            ProcessProc => \&Process_gps0,
+        },
+    },
+    gsen => { #PH (DuDuBell M1, VSYS M6L)
+        Name => 'GSensor',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::QuickTime::Stream',
+            ProcessProc => \&Process_gsen,
+        },
+    },
+    # gpsa - seen hex "01 20 00 00" (DuDuBell M1, VSYS M6L)
+    # gsea - 20 bytes hex "05 00's..." (DuDuBell M1) "05 08 02 01 ..." (VSYS M6L)
+   'GPS ' => {  # GPS data written by 70mai dashcam (parsed in QuickTimeStream.pl)
+        Name => 'GPSDataList2',
+        Unknown => 1,
+        Binary => 1,
+    },
 );
 
@@ -326,5 +735,17 @@
         Format => 'undef[$size-8]',
         # ignore any entry with a null, and return others as a list
-        ValueConv => 'my @a=($val=~/.{4}/sg); @a=grep(!/\0/,@a); \@a', 
+        ValueConv => 'my @a=($val=~/.{4}/sg); @a=grep(!/\0/,@a); \@a',
+    },
+);
+
+# proprietary HTC atom (HTC One MP4 video)
+%Image::ExifTool::QuickTime::HTCInfo = (
+    PROCESS_PROC => \&ProcessMOV,
+    GROUPS => { 2 => 'Video' },
+    NOTES => 'Tags written by some HTC camera phones.',
+    slmt => {
+        Name => 'Unknown_slmt',
+        Unknown => 1,
+        Format => 'int32u', # (observed values: 4)
     },
 );
@@ -351,5 +772,6 @@
 # image description data block
 %Image::ExifTool::QuickTime::ImageDesc = (
-    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    PROCESS_PROC => \&ProcessHybrid,
+    VARS => { ID_LABEL => 'ID/Index' },
     GROUPS => { 2 => 'Image' },
     FORMAT => 'int16u',
@@ -385,4 +807,5 @@
 #            v410 => "Uncompressed Y'CbCr, 10-bit 4:4:4",
 #            v210 => "Uncompressed Y'CbCr, 10-bit 4:2:2",
+#            hvc1 => 'HEVC', #PH
 #        },
     },
